/*
 *				**** Get Info Driver ****
 *
 * This is the dummy driver for the GetInfo Loc package
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getinfo.h"

int get_handle(int h);

int main()
{
	char buf[BUFSIZ], *s;
   int acct;
   float bal;
   int h;		/* handle */
   int opt;		/* option */
   int running=1;		/* run flag */

   printf("GetInfo Loc Package Driver\n");

   while (running)
   {
      printf("Options are:\n 1. Create entry\n 2. Delete entry\n");
      printf(" 3. Get acct\n 4. Set acct\n 5. Get fname\n 6. Set fname\n");
      printf(" 7. Get lname\n 8. Set lname\n 9. Get bal\n10. Set bal\n");
      printf("\n99. Exit\n");
      printf("\nEnter option: ");
      gets(buf);
      opt = atoi(buf);
      switch(opt)
      {
      case 1: /* create entry */
      	h = create_info();
         printf("Entry handle is %d\n", h);
         break;
      case 2: /* delete entry */
      	printf("Deleting an entry\n");
         h = get_handle(h);
      	free_info(h);
			break;
      case 3: /* get account ID */
      	printf("Get account ID\n");
         h = get_handle(h);
         acct = get_info_acct(h);
         printf("acct is %d\n", acct);
         break;
		case 4: /* set account number */
      	printf("Set account ID\n");
         h = get_handle(h);
         printf("Account number: ");
         gets(buf);
         acct = atoi(buf);
         set_info_acct(h, acct);
         display_info(h);
         break;
      case 5: /* get fname */
      	printf("Get fname\n");
         h = get_handle(h);
         s = get_info_fname(h);
         printf("fname >>%s<<\n", s);
         break;
      case 6:
      	printf("Set fname\n");
         h = get_handle(h);
         printf("Enter fname: ");
         gets(buf);
         set_info_fname(h, buf);
         display_info(h);
         break;
      case 7:
      	printf("Get lname\n");
         h = get_handle(h);
			s = get_info_lname(h);
         printf("lname >>%s<<\n", s);
         break;
      case 8:
      	printf("Set lname\n");
         h = get_handle(h);
         printf("Enter lname: ");
         gets(buf);
         set_info_lname(h, buf);
         display_info(h);
         break;
      case 9:
      	printf("Get bal\n");
         h = get_handle(h);
         bal = get_info_bal(h);
         printf("bal=%.2f\n", bal);
         break;
      case 10:
      	printf("Set bal\n");
         h = get_handle(h);
         printf("Enter balance: ");
         gets(buf);
         bal = atof(buf);
         set_info_bal(h, bal);
         display_info(h);
         break;
      case 99:
      	printf("Are you sure? (y or n): ");
         gets(buf);
         running = (*buf != 'y');
         break;
      default:
      	printf("Invalid option (%s)\n", buf);
		} /* end switch statement */
   } /* end while(running) loop */

   printf("Programming terminating\n");
	return 0;
} /* end main routine */

int get_handle(int h)
{
	char buf[BUFSIZ];
   int ret;

   printf("Enter handle [%d]: ", h);
   gets(buf);
   if (*buf == '\0') ret = h;
   else ret = atoi(buf);
   return ret;
}

